
// Run the query, build an array of links so they can be split 
// in the middle.  Along the way, tally up membership in folders.
// This tally will be extended to a full path by v0.5.
function mozwhoFind(params) {
  var searchURI = "find:datasource=rdf:bookmarks" + params;
	var docHTML = '';
	var pathHTML = '';
	var path, arcCursor,parent;
	var paths = new Object();
	var arlinks = new Array(1);
	var contents, child, name, description, markurl;
	var resultMarkDS = RDF.GetDataSource("rdf:localsearch");
  dump("Processing " + searchURI + "\n");
  var node = RDF.GetResource(searchURI);    
	resultMarks= resultMarkDS.GetTargets(node, kNC_child, true);
    while (resultMarks.hasMoreElements()) {
    	child = resultMarks.getNext().QueryInterface(Components.interfaces.nsIRDFResource);
    	dump("Looping over " + child.Value + "\n");
			name = Bookmarks.GetTarget(child, kNC_Name, true).QueryInterface(Components.interfaces.nsIRDFLiteral).Value;
    	markurl =  Bookmarks.GetTarget(child, kNC_URL, true).QueryInterface(Components.interfaces.nsIRDFLiteral).Value;
			arcCursor = Bookmarks.ArcLabelsIn(child); 
			path = Bookmarks.GetTarget(RDF.GetResource(getParentFolder(child, arcCursor)), kNC_Name, true).QueryInterface(Components.interfaces.nsIRDFLiteral).Value ;
			if(!paths[path]) { paths[path] = 1 } else { paths[path]++;}
			if(name) arlinks[arlinks.length] = "<a href='" + markurl + "' path='" + path +"'>" + name + "</a><br/>";  
			
	}
	if(arlinks.length) {
		document.getElementById("breadcrumbs").innerHTML = '<a href="bookmarks.html?nodes=NC:BookmarksRoot&labels=Home">Home</a>' + ' >> Search for ' + document.getElementById("mozwhoSearchTerms").value;
		document.getElementById("folders").innerHTML = '';
		document.getElementById("marks").innerHTML = '';
		var splitpoint = Math.round(arlinks.length / 2);
		var total = arlinks.length;
		for(var i=1;i<total;i++) {
			docHTML += arlinks[i];
			if(i == splitpoint) {
				document.getElementById("leftcolumn").innerHTML = docHTML;
				docHTML = '';
			} 
		}
		document.getElementById("rightcolumn").innerHTML = docHTML;
		
		// Write Header
		for(var j in paths) {
			pathHTML += "<a href='bookmarks.html?nodes=NC:BookmarksRoot'>" + j + "</a> (" + paths[j] + ")<br/>";		
		}
		document.getElementById("headerpanel").innerHTML = pathHTML;
	} else {
			// no links found
	}
	for(var i in paths) dump(i + " " + paths[i] + "\n");
}